#define echoPin 2 // Pin to receive echo pulse
#define trigPin 4 // Pin to send trigger pulse

int pinDirA = 7; // Pin di direzione motore A (destro)
int pinDirB = 8; // Pin di direzione motore B (sinistro)
int pinPwmA = 3; // Pin PWM motore A (destro)
int pinPwmB = 11; // Pin PWM motore B (sinistro)
float raddrizzaFactor = 1.08; // Per compensare eventuali differenze nella velocità dei due motori (>1 avvantaggia il sinistro, <1 il destro)
#define Ts 100 // tempo tra una lettura US e la successiva
long oldTime = 0; // tempo ultima lettura 

#define potenzaPWM 100

int distanzaLetta; // distanza letta dall'US
 
void setup()
 {
   // Tutti i pin dei due motori sono settati in output:
   pinMode( pinDirA,OUTPUT );
   pinMode( pinPwmA,OUTPUT );
   pinMode( pinDirB,OUTPUT );
   pinMode( pinPwmB,OUTPUT );

   // Per la comunicazione delle letture IR col serial monitor
   // Serial.begin(9600);   
   // Parte di comunicazione con sensore a ultrasuoni SRF04
   pinMode(echoPin, INPUT); // Il pin del segnale di eco del sensore
   pinMode(trigPin, OUTPUT); // Il pin del segnale di output del sensore
   oldTime = millis();
 }
 
void loop()
 {
   if (millis()-oldTime>Ts) // Una misura al più ogni tot
   {   
     oldTime = millis();
     distanzaLetta = distanzaUS();
//   Serial.println(distanzaLetta);
   }
   
   if (distanzaLetta < 20) // Ho un ostacolo davanti e devo cambiare direzione
   {
     if (random(100)<50) // al 50% giro a sinistra
     { 
       // Giro a sinistra
        digitalWrite(pinDirA,HIGH);
        digitalWrite(pinDirB,LOW);
     }
     else
     { 
       // Giro a destra
        digitalWrite(pinDirA,LOW);
        digitalWrite(pinDirB,HIGH);
     }
     analogWrite(pinPwmA,potenzaPWM);
     analogWrite(pinPwmB,int(potenzaPWM*raddrizzaFactor));
     delay(random(500,1500)); // giro per un certo tempo casuale
   }
   else  // non ci sono ostacoli e posso andare dritto
   {
     digitalWrite( pinDirA,HIGH);
     digitalWrite( pinDirB,HIGH);
   
     analogWrite( pinPwmA,potenzaPWM);
     analogWrite( pinPwmB,int(potenzaPWM*raddrizzaFactor) );
   }
 }
 
 int distanzaUS() // Funzione lettura sensore a ultrasuoni
 {
   int impulsi;
   
   digitalWrite(trigPin, LOW);                   // Set the trigger pin to low for 2uS
   delayMicroseconds(2);
   digitalWrite(trigPin, HIGH);                  // Send a 10uS high to trigger ranging
   delayMicroseconds(10);
   digitalWrite(trigPin, LOW);                   // Send pin low again
   impulsi = pulseIn(echoPin, HIGH);            // Read in times pulse
   return int(impulsi/58);                        // Calculate distance from time of pulse
 }
   
