// Questo sketch fa suonare il buzzer con una frequenza che dipende dalla luce rilevata da una fotoresistenza

int buzzer = 9; // Il buzzer su digital pin 9
int fotoRes = 0; // La fotoresistenza su analog pin 0
int nota;

void setup()
{
  pinMode(buzzer,OUTPUT); // Il digital pin 9 viene definito in modalità output
}

void loop()
{

  nota = 3*(analogRead(fotoRes)) + 500; /* Leggiamo il potenziometro associato alla fotoResistenza e lo trasformiamo per avere un range più interessante di frequenze.
  Le frequenze più interessanti del buzzer infatti variano grosso modo da 500 a 3200 Hz (vedi cap. 8, pag. 65, del libro Primi Passi), mentre la fotoresistenza al 
  variare della luce restituisce grosso modo valori che, convertiti nell'intervallo 0-1023 risultano compresi tra 3 e 900. Per mappare l'intervallo 3-900 in 500-3200, 
  si usa la funzione indicata prima*/
  
  tone(buzzer,nota); // Il tono ha la frequenza di 'nota'. Il comando tone genera un'onda quadra con frequenza 'nota' e duty cycle 50%
  
  delay(10); // Il ritardo serve per evitare false letture sul pin analogico 0 (il convertitore D/A ha bisogno di un po' di tempo per essere di nuovo pronto)

}
