// Questo sketch permette di muovere un servomotore mediante un potenziometro scrivendo il valore dell'angolo sul serial monitor

#include <Servo.h>

Servo servo1;

int pot = 0; // il cursore del potenziometro collegato ad A0
int posizione; // La posizione del cursore del potenziometro
int gradi; // La posizione del servomotore 

void setup()
{
  servo1.attach(9); // Colleghiamo virtualmente il servomotore al pin 9
  Serial.begin(9600);  // Inizializziamo la comunicazione seriale
}

void loop()
{
  posizione = analogRead(pot); // legge il potenziometro
  gradi = map(posizione,0,1023,0,179); // mappa da una scala da 0 a 1024 (la lettura analogica del potenziometro è a 1024 livelli) a una scala da 0 a 179 (i 180 gradi del motore)
  servo1.write(gradi); // sposta il motore alla posizione corrispondente a gradi
  Serial.println(gradi); // scriviamo il valore dei gradi sul Serial Monitor
  delay(200); // il solito ritardo prima di ricominciare il ciclo
}
