// Questo sketch legge un sensore a ultrasuoni e scrive la distanza corrispondente sul Serial Monitor

#define echoPin 13  // Pin to receive echo pulse
#define trigPin 12  // Pin to send trigger pulse

void setup()
{
  Serial.begin(9600);
  pinMode(echoPin, INPUT);
  pinMode(trigPin, OUTPUT);
}

void loop()
{
  digitalWrite(trigPin, LOW);                   // Set the trigger pin to low for 2uS
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);                  // Send a 10uS high to trigger ranging
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);                   // Send pin low again
  int distance = pulseIn(echoPin, HIGH);        // Read in times pulse
  distance = distance/58;                        // Calculate distance from time of pulse
  Serial.println(distance);                     // Print the distance on the Serial Monitor
  delay(1000);                                    // Wait 1 sec before next ranging
}
