#include <Servo.h>

#define echoPin 2 // Pin to receive echo pulse
#define trigPin 3 // Pin to send trigger pulse

Servo servo1;

int gradi; // La posizione del servomotore 
int distance = 0; // la distanza letta con l'SRF04 (espressa in cm)

void setup()
{
  Serial.begin(9600);
  pinMode(echoPin, INPUT);
  pinMode(trigPin, OUTPUT);
  servo1.attach(9); // Colleghiamo virtualmente il motore al pin 9
}

void loop()
{
  digitalWrite(trigPin, LOW);                   // Set the trigger pin to low for 2uS
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);                  // Send a 10uS high to trigger ranging
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);                   // Send pin low again
  distance = pulseIn(echoPin, HIGH);            // Read in times pulse
  distance= distance/58;                        // Calculate distance from time of pulse
  Serial.println(distance);                     
  if (distance > 100)
  {
    distance = 100;
  }
  if (distance < 0)
  {
    distance = 0;
  }
  gradi = map(distance,0,100,0,179); // mappa da una scala da 0 a 100 a una scala da 0 a 179 (i 180 gradi del motore)
  servo1.write(gradi); // sposta il motore della posizione gradi

  delay(1000);  // Wait before next ranging
}
